#include "statusbar.h"
#include "areaio.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <gnome.h>
#include "defines.h"
#include "callbacks.h"
#include "vroom.h"
#include "levels.h"
#include <time.h>

int ml;
extern _vroom;
extern _vexitnode;
extern _vroom;
extern struct _vroom* head;
extern struct _level* cur_level;
int file_write(char *ln,FILE *fde,char symbol);
extern root;

struct _loadroom
{
	int id;
	int x;
	int y;
	int level;
	int edited;
	char *oexits;
	char *misc_exits;
};

struct _lexit 
{
	struct _vroom *room_ptr;
	double exits_to[10];
	char *misc_e;
	struct _lexit *next;
	struct _lexit *prev;
};

struct _lexit *le_head;


int load_room(struct _loadroom *vrr);


int save_area(char *name)
{
	struct _vroom *tmp;
	char *hm;
	char s_file[200];
	char line[300];
	char ff[20];
	char hmf[300];
	FILE *fd;
	struct _level *cl;
	int num_levs;
	struct _vexitnode *ex;
	int i;
	char todo[1000];
	FILE *afd;
	int cch;
	
	cl=cur_level;
	while (cl->prev!=0) cl=cl->prev;

	sprintf(ff,"%i",cl->lev_id);

	strcpy(line,ff);
	strcat(line,":");


	num_levs=0;
	while (cl!=0)
	{	
		num_levs++;
		cl=cl->next;
	}

	sprintf(ff,"%i",num_levs);
	strcat(line,ff);
	tmp=head;
	
	strcpy(s_file,name);
	
	fd=fopen(s_file,"w");
	if (fd<=0)
	{
		mdialog_msg("Unable to save area\n Check Permissions");
		return;
	}
	
	file_write(line,fd,'H');
	
	while (tmp!=0)
	{
		strcpy(line,tmp->id);
		file_write(line,fd,'X');
		sprintf(line,"%i",tmp->x);
		file_write(line,fd,'X');
		sprintf(line,"%i",tmp->y);
		file_write(line,fd,'X');
		sprintf(line,"%i",tmp->edited);
		file_write(line,fd,'X');
		sprintf(line,"%i",tmp->rlevel->lev_id);
		file_write(line,fd,'X');


		strcpy(line,":");

		for (i=0; i<8; i++)
		{	
			if (tmp->room_ptr[i]==0) strcat(line,"-1");
			else strcat(line,tmp->room_ptr[i]->id);
			strcat(line,":");
		}
		

		if (tmp->up) strcat(line,tmp->up->id);		
		else strcat(line,"-1");
		strcat(line,":");
		
		if (tmp->down) strcat(line,tmp->down->id);
		else strcat(line,"-1");
		strcat(line,":");
		
		file_write(line,fd,'X');
		
		ex=tmp->head_exit;
		
		strcpy(line,":");
		while (ex!=0)
		{
			strcat(line,ex->ex_name);
			strcat(line,":");
			strcat(line,ex->room_ptr->id);
			strcat(line,":");
			ex=ex->next;
		}
		
		file_write(line,fd,'X');
		tmp=tmp->next;
	}
	
	strcpy(todo," ");
	file_write(todo,fd,'S');

	tmp=head;
	
	hm=getenv("HOME");
	strcpy(hmf,hm);
	strcat(hmf,"/.mudsbuilder/");
	free(hm);
	while (tmp!=0)
	{
		if (tmp->edited==1)
		{
			strcpy(todo,hmf);
			strcat(todo,".tmpsaved_");
			strcat(todo,(char*)basename(get_areaname()));
			strcat(todo,"_room");
			strcat(todo,tmp->id);

			afd=fopen(todo,"r");
			if (afd<=0) 
			{
				g_print("Room file not found\n");
				g_print("Corrupting saved file:)\n");
				fclose(fd);
				return;
			}
			putc('F',fd);
			
			do
			{
				cch=getc(afd);
				if (cch!=EOF)
				{
					putc(cch,fd);
					if (cch=='\n')
					{
						putc('F',fd);
					}
				}
			}
			while (cch!=EOF);

			putc('\n',fd);
			strcpy(todo," ");

			if (tmp->next!=0) file_write(todo,fd,'N');
			fclose(afd);
			
		}
		tmp=tmp->next;
	}


	
	fclose(fd);
}

int load_area(char *name)
{
	char line[200];
	char fname[100];
	FILE *fd,*of;
	char cty;
	struct _vroom *newroom;
	struct _loadroom nroom;
	char *mbdir;
	char *tmpdr;
	char sid[20];

	int __edited[100];
	int ei,lptr,line_c,xx,ix,rread, ch, newfile;

	double texits_to[8];
	struct _vroom *groom;
	struct _vroom *saved_r;
	char *nline,*hm;
	struct _lexit *tmple;
	struct _lexit *sle;
	int ntotrooms;

	ntotrooms=0;
	strcpy(fname,name);
	le_head=0;
	memset(line,0x0,200);
	fd=fopen(fname,"r");
	
	for (ei=0; ei<100; ei++) __edited[ei]=0;
	
	if (fd<=0) {
		g_print("Unable to open file\n");
		mdialog_msg("Error: Unable to open file");
		return;
	}
	
	line_c=0;
	lptr=0;
	on_new1_activate(0,0);
	set_root(root);
	ei=0;
	ch=(int)getc(fd);

	if (ch!='H') 
	{
		mdialog_msg("Not a room file\n");
		fclose(fd);
		return;
	}
	fclose(fd);

	fd=fopen(fname,"r");

	do
	{
		ch=(int)getc(fd);

		if (ch!=EOF)
		{
			if (ch!='\n')
			{
				line[lptr]=ch;
				lptr++;
			} else {
				line[lptr]='\0';
				lptr=0;

				if (line[0]=='H') load_levels(line);
				if (line[0]=='X')
				{
					if (line_c==7) {
					line_c=0; 
					}
					
					line[0]=' ';
					switch (line_c)
					{
						case 0: nroom.id=atoi(line); break;
						case 1: nroom.x=atoi(line); break;
						case 2: nroom.y=atoi(line); break;
						case 3: nroom.edited=atoi(line); 
							if (nroom.edited==1)
							{__edited[ei]=nroom.id; ei++;}
							break;
						case 4: nroom.level=atoi(line); break;
						case 5:
						
						nroom.oexits=malloc(sizeof(char)*(strlen(line)+1));
						strcpy(nroom.oexits,line); 
						break;

						case 6:
						nroom.misc_exits=malloc(sizeof(char)*(strlen(line)+1));
						strcpy(nroom.misc_exits,line);
						break;
						
					}
					
		
					line_c++;
					if (line_c==7)
					{
						if (nroom.id>ntotrooms) ntotrooms=nroom.id;
						load_room(&nroom);
						free(nroom.oexits);
						free(nroom.misc_exits);
					}
				}

				
			}
		}
	}
	while (ch!=EOF && line[0]!='S');
	//linking exits
	tmple=le_head;
	
	while (tmple!=0)
	{
		for (xx=0; xx<8; xx++)
		texits_to[xx]=(double)(tmple->exits_to[xx]);
		
		
		for (xx=0; xx<8; xx++)
		{
		//aha.. damn slow i know..
			if (tmple->exits_to[xx]!=-1)
			{
				groom=get_room_by_id(tmple->exits_to[xx]);
				if (groom!=0)
				groom->room_ptr[7-xx]=tmple->room_ptr;
			}
		}

		//sets exits only graphically
		set_curroom(tmple->room_ptr);
		switch_to_current_level();
		set_exits(tmple->room_ptr,texits_to);
		
		saved_r=tmple->room_ptr;
		if (tmple->exits_to[8]!=-1)
		{
			groom=get_room_by_id(tmple->exits_to[8]);
			tmple->room_ptr->up=groom;
			groom->down=tmple->room_ptr;
			show_up(tmple->room_ptr);
			show_down(groom);
		}
		
		if (tmple->exits_to[9]!=-1)
		{
			groom=get_room_by_id(tmple->exits_to[9]);
			tmple->room_ptr->down=groom;
			groom->up=tmple->room_ptr;
			show_down(tmple->room_ptr);
			show_up(groom);
		}
		
		
		load_misc_exits(tmple);

		tmple=tmple->next;
	}

	set_curroom(saved_r);
	switch_to_current_level();

	set_globals(saved_r->x,
		   saved_r->y,1+ntotrooms);

	of=0;
	hm=getenv("HOME");
	mbdir=malloc(sizeof(char)*(strlen(hm)+strlen(fname)+100));
	tmpdr=malloc(sizeof(char)*(strlen(hm)+strlen(fname)+100));

	strcpy(mbdir,hm);
	strcat(mbdir,"/.mudsbuilder/.tmpsaved_");
	strcat(mbdir,(char*)basename(fname));
	strcat(mbdir,"_room");
	free(hm);

	newfile=0;
	ei=0;

	if (line[0]=='S') 
	{
		newfile=1;
		lptr=0;
		do
		{
			ch=(int)getc(fd);
			if (ch!='\n')
			{
				if (ch!=EOF)
				{
					line[lptr]=ch;
					lptr++;
				}
			} 
			else 
			{
				line[lptr]='\0';
				if (line[0]=='N' || line[0]=='S') newfile=1; 

				if (newfile==1) {
					strcpy(tmpdr,mbdir);
					sprintf(sid,"%i",__edited[ei]);
					strcat(tmpdr,sid);
				
					if (of!=0) fclose(of);
				
					of=fopen(tmpdr,"w");
				
					ei++;
					newfile=0;
				}

				if (line[0]=='F') 
				{ 
					nline=line; nline++; 
					strcat(nline,"\n");
					fwrite(nline,sizeof(char),strlen(nline),of);
				}
				
				lptr=0;
			}
		}
		while (ch!=EOF);
	}
	
	fclose(of);
	fclose(fd);
	
	tmple=le_head;
	
	while (tmple!=0)
	{
		sle=tmple;
		tmple=tmple->next;
		free(sle->misc_e);
		free(sle);
	}
	set_areaname(fname);
	
	free(mbdir);
	free(tmpdr);
}


int file_write(char *ln,FILE *fd,char symbol)
{
	char *bl;
	bl=malloc(sizeof(char)*(strlen(ln)+5));
	
	bl[0]=symbol;
	bl[1]='\0';

	strcat(bl,ln);
	strcat(bl,"\n");
	fwrite(bl,sizeof(char),strlen(bl),fd);
	free(bl);
}


//doesnt werk
int load_levels(char *ln)
{
	char *bla;
	char *min_lev;
	char *tot_levs;
	int tl;
	struct _level *new_level,*clsaved;
	extern notebook;
	int i;
	int levid;
	int llev;
	char lev_name[20];
	char tmp[20];
	double mx_scroll;
	GtkObject *adjj1,*adjj2;
	GnomeCanvas *newcanvas;
	GtkWidget *label;
	GtkWidget *frame;
	GtkWidget *table;
	GtkWidget *scrolled;
	GnomeCanvasGroup *newgroup;
	
	mx_scroll=GSIZE*RSIZE2;
	
	bla=malloc(sizeof(char)*strlen(ln)+1);
	strcpy(bla,ln);
	bla[0]=' ';
	min_lev=strtok(bla,":");
	tot_levs=strtok(0,":");
	
	ml=atoi(min_lev);
	tl=atoi(tot_levs);
	
	if (ml==0 && tl==1) 
	{
		free(bla);
		return;
	}
	llev=tl-abs(ml);
	clsaved=cur_level;
	
	if (ml<=0) cur_level=0;
	for (i=ml; i<llev;i++)
	{
		if (i==0) { 
			clsaved->prev=cur_level;
			cur_level=clsaved; continue;
		}

		sprintf(tmp,"%i",i);
		strcpy(lev_name,"Level ");

		if (i<0) strcat(lev_name,tmp);
		
		
		if (i>0)
		{
			strcat(lev_name,"+");
			strcat(lev_name,tmp);
		}
		
		new_level=new__level();
		newcanvas=(GnomeCanvas*)gnome_canvas_new();
		gnome_canvas_set_scroll_region(
		(GnomeCanvas*)newcanvas,0.0,0.0,mx_scroll,mx_scroll);
		table=gtk_table_new(1,1,FALSE);

		adjj1=gtk_adjustment_new(0.0,0.0,1800.0,30.0,50.0,50.0);
		
		adjj2=gtk_adjustment_new(0.0,0.0,1800.0,30.0,50.0,50.0);
		scrolled=gtk_scrolled_window_new(
		
		(GtkAdjustment*)adjj1,(GtkAdjustment*)adjj2);
	
		
		gtk_container_add(
		GTK_CONTAINER(scrolled),
		GTK_WIDGET(newcanvas));

		gtk_widget_show(scrolled);
		label=gtk_label_new(lev_name);
		
		if (i<0) 
		{
			gtk_notebook_insert_page(
			GTK_NOTEBOOK(notebook),scrolled,label,abs(ml)-abs(i));
			new_level->next=clsaved;
			clsaved->prev=new_level;
			new_level->prev=cur_level;
	
			if (cur_level) cur_level->next=new_level;
			cur_level=new_level;
		}

		
		if (i>0)
		{
			gtk_notebook_append_page(
			GTK_NOTEBOOK(notebook),scrolled,label);

			new_level->prev=cur_level;
			new_level->next=0;
			cur_level->next=new_level;
			cur_level=new_level;
		}

		cur_level->_zoom=1.0;
		newgroup=gnome_canvas_root(
		(GnomeCanvas*)newcanvas);

		cur_level->canvas=(GtkWidget*)newcanvas;
		cur_level->group=newgroup;
		cur_level->lev_id=i;
		draw_grid(cur_level,GRID_COLOR);

		gtk_widget_show((GtkWidget*)newcanvas);
		g_signal_connect((gpointer)cur_level->canvas,
		"button_press_event",
		G_CALLBACK (on_canvas1_button_press_event),
		NULL);

	}
	
	gtk_notebook_set_page(GTK_NOTEBOOK(notebook),-1);
	free(bla);
	
}



int load_room(struct _loadroom* room)
{
	int oexits[10];
	char *s1;
	char id[30];
	struct _vroom *nroom;
	extern notebook;
	struct _lexit *new_lexit;
	int i;
	int gotolev;
	
	s1=strtok(room->oexits,":");
	

	new_lexit=malloc(sizeof(struct _lexit));
	new_lexit->prev=0;
	new_lexit->next=0;
	
	new_lexit->misc_e=malloc(sizeof(char)*(strlen(room->misc_exits)+2));
	strcpy(new_lexit->misc_e,room->misc_exits);

	for (i=0; i<10;i++)
	{
		s1=strtok(0,":");
		new_lexit->exits_to[i]=(double)atoi(s1);
	}
	
	if (le_head==0) le_head=new_lexit;
	else {
		new_lexit->next=le_head;
		le_head->prev=new_lexit;
		le_head=new_lexit;
	}
	
	sprintf(id,"%i",room->id);
	

	gotolev=abs(room->level);
	
	gtk_notebook_set_page(GTK_NOTEBOOK(notebook),abs(ml)+room->level);
	nroom=new_vroom();
	new_room(nroom,id,(double)room->x,(double)room->y);
	nroom->rlevel=cur_level;
	nroom->edited=room->edited; //edited

	if (head==0) {
		head=nroom;
		nroom->prev=0; nroom->next=0;
	} else {
		nroom->next=head;
		head->prev=nroom;
		head=nroom;
	}
	new_lexit->room_ptr=nroom;
	
}



int load_misc_exits(struct _lexit *cr)
{
	char *s1;
	int id;
	char *ex_name;
	char err_msg[500];
	struct _vroom *grr;
	struct _vexitnode *new_node;
	
	GnomeCanvasPoints *pz;
	struct _vroom *myroom;

	myroom=cr->room_ptr;
	
	myroom->head_exit=0;
	s1=strtok(cr->misc_e,":");
	do
	{
		s1=strtok(0,":");
		if (s1) {
			new_node=malloc(sizeof(struct _vexitnode));
			new_node->ex_name=malloc(sizeof(char)*(strlen(s1)+1));
			strcpy(new_node->ex_name,s1);
			
			s1=strtok(0,":");
			id=atoi(s1);
			grr=get_room_by_id(id);
			if (grr!=0)
			{
				new_node->room_ptr=grr;
				new_node->next=0;
				new_node->prev=0;
			
				if (myroom->head_exit==0) myroom->head_exit=new_node;
				else 
				{
					new_node->next=myroom->head_exit;
					myroom->head_exit->prev=new_node;
					myroom->head_exit=new_node;	
				}

				pz=gnome_canvas_points_new(2);
				pz->coords[0]=myroom->x+RSIZE1;
				pz->coords[1]=myroom->y+RSIZE1;
				pz->coords[2]=new_node->room_ptr->x+RSIZE1;
				pz->coords[3]=new_node->room_ptr->y+RSIZE1;
				
				new_node->line=gnome_canvas_item_new(
				myroom->rlevel->group,
				GNOME_TYPE_CANVAS_LINE,
				"points",pz,
				"fill_color",EXIT_COLOR,
				"last_arrowhead",TRUE,
				"arrow_shape_a",14.0,
				"arrow_shape_b",19.0,
				"arrow_shape_c",4.0,
				NULL);

				gnome_canvas_points_free(pz);
			}
			else
			{
				strcpy(err_msg,"Critical Error: Was not able to properly link or load one of rooms.");
				strcat(err_msg,"\nIt most likely means that you have found bug\n");
				strcat(err_msg,"Please report it to frostedcmos@yahoo.com\nThanks\n");
				mdialog_msg(err_msg);
			}
			
		}
		
	}
	while (s1!=0);
	

}
